/** 
	 * VncCanvasActivity.java
	 * Archivo original: http://code.google.com/p/android-vnc-viewer/source/browse/branches/antlersoft/androidVNC/src/android/androidVNC/VncCanvasActivity.java
	 * Release original: 39.
	 * Release actual: 60
	 * Modificado por: Alberto Poblacion Navarro
	 * Aadido
	 *	- Declaracion Sensores sensor;
	 *  - Declaracion private Notificacion notificacion
	 *  - Declaracion private AndroidLog log;
	 *	- Aadido R.id.itemInputFullMouseControl
	 *	- Aadido case R.id.itemScreenshot 
	 *  - Aadido case R.id.itemacelerometro  
	 *  - Aadido case R.id.itemorientacion
	 *  - Aadido case R.id.itembrujula
	 *  - Aadido case R.id.itemZoom
	 *  - Aadido case R.id.itemPegar
	 *  - Aadido case R.id.itemScreenshot:
	 *  - Aadido case R.id.itemLog:
	 *  - Aadido case R.id.itemFileTransfer:
	 *  - Aadido metodo onActivityResult;
	 *  - Aadido metodo en OnConfigurationChanged
	 *  - Aadido declaracion de FileTransfer ft y su iniciacion de manera estatica
	 *  - Aaadida funcion para devolver la instancia de Filetransfer con el lienzo y la actividad
	 * Modificaciones: 	  
	 *  - Modificada private static final int inputModeIds[] = { R.id.itemInputFitToScreen, R.id.itemInputMouse, R.id.itemInputPan, R.id.itemInputTouchPanTrackballMouse, R.id.itemInputFullMouseControl};
	 *  - Modificacion case R.id.itemOneToOne en vez de poner la imagen centrado
	 *  	se utilizada una matriz para mayor compatibilidad de el zoom.
	 
 */
/* 
 * This is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,
 * USA.
 */

//
// CanvasView is the Activity for showing VNC Desktop.
//
package android.androidVNC;

import java.text.MessageFormat;
import java.util.ArrayList;

import android.app.Activity;
import android.app.Dialog;
import android.app.ProgressDialog;
import android.content.ContentValues;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.DialogInterface.OnDismissListener;
import android.content.res.Configuration;
import android.database.Cursor;
import android.graphics.Matrix;
import android.os.Bundle;
import android.os.Environment;
import android.util.Log;
import android.view.Display;
import android.view.KeyEvent;
import android.view.Menu;
import android.view.MenuItem;
import android.view.MotionEvent;
import android.view.View;
import android.view.Window;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.ListView;
import android.widget.Toast;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.ImageView.ScaleType;
/** 
 * <p>(Se omiten acentos)</p>
 * <p>VncCanvasActivity.java</p>
 * <p><b>Archivo original:</b></p> 
 * <p>Web: http://code.google.com/p/android-vnc-viewer/source/browse/branches/antlersoft/androidVNC/src/android/androidVNC/VncCanvasActivity.java/</p>
 * <p>Release original: 39.</p>
 * <p>Release actual: 60</p>
 * <p>Modificado por: Alberto Poblacion Navarro</p>
 * <p><b>Aadido:</b></p>
 * <p>Declaracion Sensores sensor;</p>
 * <p>Declaracion private Notificacion notificacion</p>
 * <p>Declaracion private AndroidLog log;</p>
 * <p>Aadido R.id.itemInputFullMouseControl</p>
 * <p>Aadido case R.id.itemScreenshot </p>
 * <p>Aadido case R.id.itemacelerometro  </p>
 * <p>Aadido case R.id.itemorientacion</p>
 *  <p>Aadido case R.id.itembrujula</p>
 *  <p>Aadido case R.id.itemZoom</p>
 *  <p>Aadido case R.id.itemPegar</p>
 *  <p>Aadido case R.id.itemScreenshot:</p>
 *  <p>Aadido case R.id.itemLog:</p>
 *  <p>Aadido case R.id.itemFileTransfer:</p>
 *  <p>Aadido metodo onActivityResult;</p>
 *  <p>Aadido metodo en OnConfigurationChanged</p>
 *  <p>Aadido declaracion de FileTransfer ft y su iniciacion de manera estatica</p>
 *  <p>Aadida funcion para devolver la instancia de Filetransfer con el lienzo y la actividad</p>
 * <p><b>Modificaciones:</b></p> 	  
 *  <p>Modificada private static final int inputModeIds[] = { R.id.itemInputFitToScreen, R.id.itemInputMouse, R.id.itemInputPan, R.id.itemInputTouchPanTrackballMouse, R.id.itemInputFullMouseControl};</p>
 *  <p> Modificacion case R.id.itemOneToOne en vez de poner la imagen centrado
 *  	se utilizada una matriz para mayor compatibilidad de el zoom.</p>
 
*/
public class VncCanvasActivity extends Activity {

	private final static String TAG = "VncCanvasActivity";

	AbstractInputHandler inputHandler;
	
	VncCanvas vncCanvas;
	
	VncDatabase database;

	private Notificacion notificacion;
	private AndroidLog log;
		
	private MenuItem[] inputModeMenuItems;
	private AbstractInputHandler inputModeHandlers[];
	private ConnectionBean connection;
	private boolean trackballButtonDown;
	private static final int inputModeIds[] = { R.id.itemInputFitToScreen, R.id.itemInputMouse, R.id.itemInputPan, R.id.itemInputTouchPanTrackballMouse, R.id.itemInputFullMouseControl};

	@Override
	public void onCreate(Bundle icicle) {

		super.onCreate(icicle);
		requestWindowFeature(Window.FEATURE_NO_TITLE);
		//Mostramos la barra de estado
		//getWindow().setFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN, WindowManager.LayoutParams.FLAG_FULLSCREEN);
		
		database = new VncDatabase(this);
		
		notificacion = Notificacion.Instancia(this);
		notificacion.notificar(getString(R.string.app_name),getString(R.string.running));
		log = AndroidLog.Instancia();
		
		Bundle extras = getIntent().getExtras();
		
		connection=new ConnectionBean();
		connection.Gen_populate((ContentValues)extras.getParcelable(VncConstants.CONNECTION));
		if (connection.getPort() == 0)
			connection.setPort(5900);

		// Parse a HOST:PORT entry
		String host=connection.getAddress();
		if (host.indexOf(':') > -1) {
			String p = host.substring(host.indexOf(':') + 1);
			try {
				connection.setPort( Integer.parseInt(p) );
			} catch (Exception e) {
			}
			connection.setAddress( host.substring(0, host.indexOf(':')));
		}

		vncCanvas = new VncCanvas(this, connection, new Runnable() {
			public void run() {
				setModes();
			}
		});
		
		
		setContentView(vncCanvas);
		inputHandler=getInputHandlerById(R.id.itemInputFitToScreen);
	}
	
	/**
	 * Set modes on start to match what is specified in the ConnectionBean; color mode (already done)
	 * scaling, input mode
	 */
	void setModes() {
		ft=FileTransfer.Instancia(vncCanvas, this);
		// If scale mode is not default
		if ( connection.getScaleMode() != ScaleType.FIT_CENTER)
		{
			//vncCanvas.setScaleType(connection.getScaleMode());
			//vncCanvas.scrollTo(-vncCanvas.getCenteredXOffset(),-vncCanvas.getCenteredYOffset());
			vncCanvas.setScaleType(ScaleType.MATRIX);
			connection.setScaleMode(ScaleType.MATRIX);
			AbstractInputHandler input = getInputHandlerByName(connection.getInputMode());
			if (input != null) {
				inputHandler = input;
			}
			updateInputMenu();
		}
	}
	
	ConnectionBean getConnection()
	{
		return connection;
	}
	
	/**
	 * Make sure mouse is visible on displayable part of screen
	 */
	void panToMouse()
	{
		if (! connection.getFollowMouse() || isFitToScreen() || (inputHandler.getName()=="FULL MOUSE"))
			return;
		int x = vncCanvas.mouseX;
		int y = vncCanvas.mouseY;
		boolean panned = false;
		Display display = getWindowManager().getDefaultDisplay();
		int w = display.getWidth();
		int h = display.getHeight();
		AbstractBitmapData bitmapData = vncCanvas.bitmapData;
		
		int newX = absoluteXPosition;
		int newY = absoluteYPosition;
		
		if (x - newX >= w)
		{
			newX = x - w/2;
			if (newX + w > bitmapData.framebufferwidth)
				newX = bitmapData.framebufferwidth - w;
		}
		else if (x < newX)
		{
			newX = x - w/2;
			if (newX < 0)
				newX = 0;
		}
		if ( newX != absoluteXPosition ) {
			newX = newX - absoluteXPosition;
			absoluteXPosition += newX;
			panned = true;
		} else {
			newX = 0;
		}
		if (y - newY >= h)
		{
			newY = y - h/2;
			if (newY + h > bitmapData.framebufferheight)
				newY = bitmapData.framebufferheight - h;
		}
		else if (y < newY)
		{
			newY = y - h/2;
			if (newY < 0)
				newY = 0;
		}
		if ( newY != absoluteYPosition ) {
			newY = newY - absoluteYPosition;;
			absoluteYPosition += newY;
			panned = true;
		}
		else {
			newY = 0;
		}
		if (panned)
		{
			vncCanvas.scrollBy(newX, newY);
		}
	}
	
	/* (non-Javadoc)
	 * @see android.app.Activity#onCreateDialog(int)
	 */
	@Override
	protected Dialog onCreateDialog(int id) {
		return new MetaKeyDialog(this);
	}

	/* (non-Javadoc)
	 * @see android.app.Activity#onPrepareDialog(int, android.app.Dialog)
	 */
	@Override
	protected void onPrepareDialog(int id, Dialog dialog) {
		super.onPrepareDialog(id, dialog);
		((MetaKeyDialog)dialog).setConnection(connection);
	}
	
	/**
	 * Funcion llamada automaticamente cuando cambia una configuracin determinada
	 * en el dispositivo. Estas configuraciones esta declaradas en AndroidManifest.xml
	 * Ademas evita que cuando cambie la Orientacion del telefono se muestra una parte del 
	 * escritorio remoto inexistente, es decir, ajusta la posicin que se ve del
	 * servidor.
	 * @param newConfig Objeto que almacena la nueva configuracion del telefono.
	 * @author Alberto Poblacin Navarro
	 */
	@Override 
    public void onConfigurationChanged(Configuration newConfig) { 
	  // ignore orientation/keyboard change->Originalmente se ignoraba 
	  super.onConfigurationChanged(newConfig);
      //Se comprueba los limites de la pantalla      
      Display display=getWindowManager().getDefaultDisplay();
      if(absoluteXPosition+ display.getWidth()>=vncCanvas.getImageWidth()){
    	  absoluteXPosition=vncCanvas.getImageWidth()-(display.getWidth());
    	  vncCanvas.scrollTo(0, vncCanvas.getScrollY());
    	  vncCanvas.scrollTo(absoluteXPosition,vncCanvas.getScrollY());
      }
      if(absoluteYPosition+ display.getHeight()+vncCanvas.getTop()>=vncCanvas.getImageHeight()){
    	  absoluteYPosition=vncCanvas.getImageHeight()-(display.getHeight());
    	  vncCanvas.scrollTo(vncCanvas.getScrollX(),0);
    	  vncCanvas.scrollTo(vncCanvas.getScrollX(), absoluteYPosition);
      }
      
	} 

	@Override 
    protected void onStop() { 
      vncCanvas.disableRepaints(); 
      super.onStop();       
    } 

	@Override 
    protected void onRestart() { 
      vncCanvas.enableRepaints(); 
      super.onRestart();       
    } 
	
	private Menu menu_;
	/** {@inheritDoc} */
	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		menu_=menu;
		getMenuInflater().inflate(R.menu.vnccanvasactivitymenu, menu);
		
		menu.findItem(isFitToScreen() ? R.id.itemFitToScreen : R.id.itemOneToOne).setChecked(true);
		//Activamos las caracterisiticas que solo funcionan en 1:1 si estan desctivadas
		menu.findItem(R.id.itemZoom).setEnabled(!isFitToScreen());
		menu.findItem(R.id.itemScreenshot).setEnabled(!isFitToScreen());
		menu_.findItem(R.id.itemCompass).setEnabled(!isFitToScreen());
		menu_.findItem(R.id.itemOrientation).setEnabled(!isFitToScreen());
		
		
		Menu inputMenu = menu.findItem( R.id.itemInputMode).getSubMenu();
		
		inputModeMenuItems = new MenuItem[inputModeIds.length];
		for ( int i=0; i<inputModeIds.length; i++)
		{
			inputModeMenuItems[i]=inputMenu.findItem(inputModeIds[i]);
		}
		updateInputMenu();
		menu.findItem(R.id.itemFollowMouse).setChecked(connection.getFollowMouse());
		return true;
	}
	
	/**
	 * Change the input mode sub-menu to reflect change in scaling
	 */
	void updateInputMenu()
	{
		if ( inputModeMenuItems == null ) {
			return;
		}
		if ( isFitToScreen())
		{
			for ( MenuItem item : inputModeMenuItems)
			{
				item.setEnabled(false);
				if ( item.getItemId()==R.id.itemInputFitToScreen)
					item.setChecked(true);
			}
		}
		else
		{
			for ( MenuItem item : inputModeMenuItems)
			{
				int id=item.getItemId();
				item.setEnabled( id!=R.id.itemInputFitToScreen);
				if (inputHandler == getInputHandlerById(id))
				{
					item.setChecked(true);
				}
			}
		}
	}
	
	AbstractInputHandler getInputHandlerById( int id)
	{
		
		if ( inputModeHandlers==null)
		{
			inputModeHandlers=new AbstractInputHandler[inputModeIds.length];
		}
		for ( int i=0; i<inputModeIds.length; ++i)
		{
			if ( inputModeIds[i]==id)
			{
				if ( inputModeHandlers[i]==null)
				{
					switch ( id )
					{
					case R.id.itemInputFitToScreen :
						inputModeHandlers[i]=new FitToScreenMode();
						break;
					case R.id.itemInputPan :
						inputModeHandlers[i]=new PanMode();
						break;
					case R.id.itemInputMouse :
						inputModeHandlers[i]=new MouseMode();
						break;
					case R.id.itemInputTouchPanTrackballMouse :
						inputModeHandlers[i]=new TouchPanTrackballMouse();
						break;
					case R.id.itemInputFullMouseControl:
						inputModeHandlers[i]=new FullMouseMode(vncCanvas, this);
						break;
					}
				}
				return inputModeHandlers[i];
			}
		}
		return null;
	}
	
	AbstractInputHandler getInputHandlerByName(String name)
	{
		AbstractInputHandler result = null;
		for (int id : inputModeIds) {
			AbstractInputHandler handler = getInputHandlerById( id );
			if (handler.getName().equals(name)) {
				result = handler;
				break;
			}
		}
		return result;
	}

	int absoluteXPosition = 0, absoluteYPosition = 0;

	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		vncCanvas.afterMenu = true;
		switch (item.getItemId()) {
		case R.id.itemInfo:
			vncCanvas.showConnectionInfo();
			return true;
		case R.id.itemSpecialKeys:
			showDialog(R.layout.metakey);
			return true;
		case R.id.itemColorMode:
			selectColorModel();
			return true;
		case R.id.itemOneToOne:
			log.log(TAG, "Menu Item: Escala 1:1");
			inputHandler = getInputHandlerById(R.id.itemInputPan);
			item.setChecked(true);
			showPanningState();
			// Change to 1:1 scaling (which auto-centers)
			//vncCanvas.setScaleType(ScaleType.CENTER);
			//connection.setScaleMode(ScaleType.CENTER);
	//En vez de Center usamos matrix para funcionar sin problemas con el zoom
			vncCanvas.setImageMatrix(new Matrix());
			vncCanvas.setScaleType(ScaleType.MATRIX);
			//Activamos las caracterisiticas que solo funcionan en 1:1 si estan desctivadas
			menu_.findItem(R.id.itemZoom).setEnabled(true);
			menu_.findItem(R.id.itemScreenshot).setEnabled(true);
			menu_.findItem(R.id.itemCompass).setEnabled(true);
			menu_.findItem(R.id.itemOrientation).setEnabled(true);
						
			connection.setScaleMode(ScaleType.MATRIX);
			updateInputMenu();
			// Reset the pan position to (0,0) En matrix la posicion 0,0 no es necesario hacer ajustes.
			//vncCanvas.scrollTo(-vncCanvas.getCenteredXOffset(),-vncCanvas.getCenteredYOffset());
			vncCanvas.scrollTo(0,0);
			connection.setInputMode(inputHandler.getName());
			connection.save(database.getWritableDatabase());
			return true;
		case R.id.itemFitToScreen:
			log.log(TAG, "Menu Item: Escala ajustada a pantalla");
			inputHandler = getInputHandlerById(R.id.itemInputFitToScreen);
			item.setChecked(true);
			vncCanvas.setScaleType(ScaleType.FIT_CENTER);
			connection.setScaleMode(ScaleType.FIT_CENTER);
			absoluteXPosition = 0;
			absoluteYPosition = 0;
			updateInputMenu();
			vncCanvas.scrollTo(absoluteXPosition, absoluteYPosition);
			connection.setInputMode(inputHandler.getName());
			connection.save(database.getWritableDatabase());
			//Activamos las caracterisiticas que solo funcionan en 1:1 si estan desctivadas
			menu_.findItem(R.id.itemZoom).setEnabled(false);
			menu_.findItem(R.id.itemScreenshot).setEnabled(false);
			menu_.findItem(R.id.itemCompass).setEnabled(false);
			menu_.findItem(R.id.itemOrientation).setEnabled(false);
	
			return true;
		case R.id.itemCenterMouse:
			Display display=getWindowManager().getDefaultDisplay();
			vncCanvas.warpMouse( absoluteXPosition + display.getWidth()/2, absoluteYPosition + display.getHeight()/2);
			return true;
		case R.id.itemDisconnect:
			Sensores.finalizar();
			FileTransfer.finalizar();
			Zoom.finalizar();
			notificacion = Notificacion.Instancia(this);
			notificacion.notificar(getString(R.string.disconnected),getString(R.string.connection_closed));
			notificacion.eliminar();
			//vncCanvas.closeConnection();
			finish();
			return true;
		case R.id.itemCtrlAltDel:
			vncCanvas.sendMetaKey(MetaKeyBean.keyCtrlAltDel);
			return true;
		case R.id.itemFollowMouse:
			boolean newFollow = ! connection.getFollowMouse();
			item.setChecked(newFollow);
			connection.setFollowMouse(newFollow);
			if (newFollow) {
				panToMouse();
			}
			connection.save(database.getWritableDatabase());
			return true;
		case R.id.itemArrowLeft :
			vncCanvas.sendMetaKey(MetaKeyBean.keyArrowLeft);
			return true;
		case R.id.itemArrowUp :
			vncCanvas.sendMetaKey(MetaKeyBean.keyArrowUp);
			return true;
		case R.id.itemArrowRight :
			vncCanvas.sendMetaKey(MetaKeyBean.keyArrowRight);
			return true;
		case R.id.itemArrowDown :
			vncCanvas.sendMetaKey(MetaKeyBean.keyArrowDown);
			return true;
		case R.id.itemSendKeyAgain :
			sendSpecialKeyAgain();
			return true;
		case R.id.itemZoom: //Mostrar controles del zoom
			Log.d(TAG, "Menu item: Zoom controls");
			log.log(TAG, "Menu item: Zoom controls");
			if(!item.isChecked()){
				log.log(TAG, "Zoom Controls activados");
				item.setChecked(true);
				FullMouseMode.zoom_control.show();
				FullMouseMode.reset.setVisibility(View.VISIBLE);
				notificacion.notificar(getString(R.string.T_zoom_controls), getString(R.string.I_zoom_controls));
			}else{
				log.log(TAG, "Zoom Controls desactivados");
				item.setChecked(false);
				FullMouseMode.zoom_control.hide();
				FullMouseMode.reset.setVisibility(View.INVISIBLE);
				notificacion.notificar(getString(R.string.T_no_zoom_controls), getString(R.string.I_no_zoom_controls));
			}
			break;
		case R.id.itemScreenshot: //Caputara de pantalla
			log.log(TAG, "Menu item: Screenshot");
			return Screenshot.nuevo(this, vncCanvas);
		case R.id.itemPegar: //Pegar en el servidor informacion local
			log.log(TAG, "Menu item: Pegar desde el clibpoard local");
			Copiar_y_Pegar.pegar(this);
			break;
		case R.id.itemLog: //Mostrar log
			log.log(TAG, "Menu item: Log mostrado");
			notificacion.notificar(getString(R.string.log_shown));
			if(AndroidLog.getsavelog()){
				Intent intent = new Intent(this, WebViewActivity.class);
				this.startActivity(intent);
			}else{
				Toast.makeText(this, getString(R.string.no_log), Toast.LENGTH_SHORT).show();
			}
			break;
		case R.id.itemSend: //Enviar archivos
			if (Environment.getExternalStorageState().equals(Environment.MEDIA_MOUNTED)){
				log.log(TAG, "Envio de archivos al servidor");
				notificacion.notificar(getString(R.string.send));
				Intent listar = new Intent (this, ExploradorArchivosLocal.class);
				startActivityForResult(listar, 0);
			} else Toast.makeText(this, getString(R.string.no_sdcard), Toast.LENGTH_SHORT).show();
			break;
		case R.id.itemRecieve: //Recibir archivos (copiar del servidor)
			if (Environment.getExternalStorageState().equals(Environment.MEDIA_MOUNTED)){
				log.log(TAG, "Envio de archivos desde el servidor");
				notificacion.notificar(getString(R.string.receive));
				Intent listaremoto = new Intent (this, ExploradorArchivosRemoto.class);
	        	listaremoto.putExtra(ExploradorArchivosRemoto.TIPO, ExploradorArchivosRemoto.RECIBIR);
				startActivityForResult(listaremoto, 0);//Ver el shift+F2 onActivity result.
			}  else Toast.makeText(this, getString(R.string.no_sdcard), Toast.LENGTH_SHORT).show();
			break;
		case R.id.itemOrientation: //Activar sensor de orientacion
			if(item.isChecked()){
				item.setChecked(false);
				Sensores.Instancia(this, vncCanvas).quitar();
				
			}else{
				if(menu_.findItem(R.id.itemCompass).isChecked()) menu_.findItem(R.id.itemCompass).setChecked(false); 
				item.setChecked(true);
				Sensores.Instancia(this, vncCanvas).registrar(Sensores.ORIENTACION);
			}
			break;
		case R.id.itemCompass: //Activar sensor de campo magnetico
			if(item.isChecked()){
				item.setChecked(false);
				Sensores.Instancia(this, vncCanvas).quitar();
				
			}else{
				if(menu_.findItem(R.id.itemOrientation).isChecked()) menu_.findItem(R.id.itemOrientation).setChecked(false); 
				item.setChecked(true);
				Sensores.Instancia(this, vncCanvas).registrar(Sensores.BRUJULA);
			}
			break;
		default :
			AbstractInputHandler input=getInputHandlerById(item.getItemId());
			if ( input != null)
			{
				inputHandler=input;
				connection.setInputMode(input.getName());
				item.setChecked(true);
				showPanningState();
				connection.save(database.getWritableDatabase());
				return true;
			}
		}
		return super.onOptionsItemSelected(item);
	}
	
	private MetaKeyBean lastSentKey;
	
	private void sendSpecialKeyAgain()
	{
		if (lastSentKey == null || lastSentKey.get_Id() != connection.getLastMetaKeyId())
		{
			ArrayList<MetaKeyBean> keys = new ArrayList<MetaKeyBean>();
			Cursor c = database.getReadableDatabase().rawQuery(
					MessageFormat.format("SELECT * FROM {0} WHERE {1} = {2}",
							MetaKeyBean.GEN_TABLE_NAME,
							MetaKeyBean.GEN_FIELD__ID,
							connection.getLastMetaKeyId()),
					MetaKeyDialog.EMPTY_ARGS);
			MetaKeyBean.Gen_populateFromCursor(
					c,
					keys,
					MetaKeyBean.NEW);
			c.close();
			if (keys.size() > 0) {
				lastSentKey = keys.get(0);
			}
			else {
				lastSentKey = null;
			}
		}
		if (lastSentKey != null)
			vncCanvas.sendMetaKey(lastSentKey);
	}

	@Override
	protected void onDestroy() {
		super.onDestroy();
		//Log.d(TAG, "1era Fase: Fin de VncCanvasActivity");
		if (isFinishing())
		{
			vncCanvas.closeConnection();
			vncCanvas.onDestroy();
			database.close();
		}
		
		
	}
	
	@Override
	public boolean onKeyDown(int keyCode, KeyEvent evt) {
		if (keyCode == KeyEvent.KEYCODE_MENU)
			return super.onKeyDown( keyCode, evt);
		
		return inputHandler.onKeyDown(keyCode, evt);
	}
		
	@Override
	public boolean onKeyUp(int keyCode, KeyEvent evt) {
		if (keyCode == KeyEvent.KEYCODE_MENU)
			return super.onKeyUp( keyCode, evt);
		
		return inputHandler.onKeyUp(keyCode, evt);
	}

	public void showPanningState() {
		Toast.makeText(this, inputHandler.getHandlerDescription(), Toast.LENGTH_SHORT).show();
	}

	private boolean isFitToScreen() {
		return vncCanvas.getScaleType() == ScaleType.FIT_CENTER;
	}

	/* (non-Javadoc)
	 * @see android.app.Activity#onTrackballEvent(android.view.MotionEvent)
	 */
	@Override
	public boolean onTrackballEvent(MotionEvent event) {
		switch (event.getAction())
		{
		case MotionEvent.ACTION_DOWN:
			trackballButtonDown = true;
			break;
		case MotionEvent.ACTION_UP:
			trackballButtonDown = false;
			break;
		}
		return inputHandler.onTrackballEvent(event);
	}

	@Override
	public boolean onTouchEvent(MotionEvent event) {
		return inputHandler.onTouchEvent(event);
	}

	private void selectColorModel() {
		// Stop repainting the desktop
		// because the display is composited!
		vncCanvas.disableRepaints();
		
		String[] choices = new String[COLORMODEL.values().length];
		int currentSelection = -1;
		for (int i = 0; i < choices.length; i++) {
			COLORMODEL cm = COLORMODEL.values()[i];
			choices[i] = cm.toString();
			if (vncCanvas.isColorModel(cm))
				currentSelection = i;
		}

		final Dialog dialog = new Dialog(this);
		dialog.requestWindowFeature(Window.FEATURE_NO_TITLE);
		ListView list = new ListView(this);
		list.setAdapter(new ArrayAdapter<String>(this, android.R.layout.simple_list_item_checked, choices));
		list.setChoiceMode(ListView.CHOICE_MODE_SINGLE);
		list.setItemChecked(currentSelection, true);
		list.setOnItemClickListener(new OnItemClickListener() {
			public void onItemClick(AdapterView<?> arg0, View arg1, int arg2, long arg3) {
				dialog.dismiss();
				COLORMODEL cm = COLORMODEL.values()[arg2];
				vncCanvas.setColorModel(cm);
				connection.setColorModel(cm.nameString());
				connection.save(database.getWritableDatabase());
				Toast.makeText(VncCanvasActivity.this, "Updating Color Model to " + cm.toString(), Toast.LENGTH_SHORT).show();
			}
		});
		dialog.setOnDismissListener(new OnDismissListener() {
			@Override
			public void onDismiss(DialogInterface arg0) {
				Log.i(TAG, "Color Model Selector dismissed");
				// Restore desktop repaints
				vncCanvas.enableRepaints();
			}
		});
		dialog.setContentView(list);
		dialog.show();		
	}
	
	float panTouchX, panTouchY;

	/**
	 * Pan based on touch motions
	 * @param event
	 */
	private void pan(MotionEvent event) {
		float curX = event.getX();
		float curY = event.getY();
		int dX = (int) (panTouchX - curX);
		int dY = (int) (panTouchY - curY);

		// Prevent panning left or above desktop image
		if (absoluteXPosition + dX < 0)
			// dX = diff to 0
			dX = absoluteXPosition * -1;
		if (absoluteYPosition + dY < 0)
			// dY = diff to 0
			dY = absoluteYPosition * -1;

		// Prevent panning right or below desktop image
		if (absoluteXPosition + vncCanvas.getWidth() + dX > vncCanvas.getImageWidth())
			dX = 0;
		if (absoluteYPosition + vncCanvas.getHeight() + dY > vncCanvas.getImageHeight())
			dY = 0;

		absoluteXPosition += dX;
		absoluteYPosition += dY;
		vncCanvas.scrollBy(dX, dY);
	}

	boolean defaultKeyDownHandler( int keyCode, KeyEvent evt)
	{
		if ( vncCanvas.processLocalKeyEvent(keyCode, evt))
			return true;
		return super.onKeyDown(keyCode, evt);
	}
	
	boolean defaultKeyUpHandler( int keyCode, KeyEvent evt)
	{
		if ( vncCanvas.processLocalKeyEvent(keyCode, evt))
			return true;
		return super.onKeyUp(keyCode, evt);
	}
	
	boolean touchPan( MotionEvent event)
	{
		switch (event.getAction()) {
		case MotionEvent.ACTION_DOWN:
			panTouchX = event.getX();
			panTouchY = event.getY();
			break;
		case MotionEvent.ACTION_MOVE:
			pan(event);
			panTouchX = event.getX();
			panTouchY = event.getY();
			break;
		case MotionEvent.ACTION_UP:
			pan(event);
			break;
		}
		return true;		
	}
	
	boolean trackballMouse( MotionEvent evt)
	{
		int dx = (int)(evt.getX() * 6.01);
		int dy = (int)(evt.getY() * 6.01);
		
		dx = dx * dx * dx;
		dy = dy * dy * dy;
		
		evt.offsetLocation( vncCanvas.mouseX + dx - evt.getX(), vncCanvas.mouseY + dy - evt.getY());
		
		if (vncCanvas.processPointerEvent(evt,trackballButtonDown)) {
			return true;
		}
		return VncCanvasActivity.super.onTouchEvent(evt);		
	}
	
	//Variable publica para poder acceder desde otras actividades
	//a la instancia de la clase FileTransfer utilizada.
	private static FileTransfer ft;
	/**
	 * Devuelve la instancia de la clase FileTransfer utilizada
	 * @author Alberto Poblacion Navarro
	 * @return
	 */
	public static FileTransfer getFileTransfer(){
		return ft;
	}
	ProgressDialog pd;
	/** 
	 * @see android.app.Activity#onActivityResult(int, int, android.content.Intent)
	 * Se llama automaticamente esta funcion cuando finaliza la activity de la clase 
	 * ExploradorArchivosLocal. Si el resultado es positivo se mandara una peticion
	 * al servidor de envio de un archivo.
	 * La informacion del archivo local y el path remoto viene incluido en el intent.
	 * @param requestCode Codigo con el que se lanzo la actividad para identificarla.
	 * @param resutlCode codigo de retorno de la actividad.
	 * @param data Intent donde se incluye informacin adicional.
	 * @author Alberto Poblacion Navarro
	 * 
	 */
	@Override
	protected void onActivityResult(int requestCode, int resultCode, Intent data) {
		super.onActivityResult(requestCode, resultCode, data);
		String archivo;
		String path;
		//Si se han elegido los archivos necesarios.
		if(resultCode == RESULT_OK){
			
			int tipo = data.getIntExtra(ExploradorArchivosRemoto.TIPO, 0);
			final FileTransfer ft = FileTransfer.Instancia(vncCanvas, this);
			ft.fAbort=false;
			if(tipo == ExploradorArchivosRemoto.ENVIAR)
			{
				//Se obtiene del intent el archivo local y el directorio remoto
				archivo=data.getStringExtra("archivo");
				path=data.getStringExtra("path");
				//Se manda el archivo y lo notificamos al usuario
				ft.offerLocalFile(archivo, path);
				log.log(TAG, "Enviando archivo :"+archivo.toString()+"a :"+path);
				notificacion.notificar(getString(R.string.sending_file)+": "+archivo.toString());
				//Cuadro de progreso que se muestrara mientra dure la transferencia.
				pd = ProgressDialog.show(this, getString(R.string.sending)+"...",getString(R.string.sending_file)+": "+archivo.toString(), true, true, new DialogInterface.OnCancelListener() {
					@Override
					public void onCancel(DialogInterface dialog) {
						//closeConnection();
						vncCanvas.handler.post(new Runnable() {
							public void run() {
								log.log(TAG, "Tranferencia abortada");
								notificacion.notificar(getString(R.string.transfer_aborted));
								pd.setMessage(getString(R.string.transfer_aborted));
								vncCanvas.enableRepaints();
								ft.fAbort=true;
							}
						});
					}
				});
			}else if (tipo == ExploradorArchivosRemoto.RECIBIR)
			{
				//Peticin del archivo que hemos elegido
				ft.requestRemoteFile(data.getStringExtra("path"), "/sdcard/"+data.getStringExtra("archivo"));				
				notificacion.notificar(getString(R.string.receiving_file)+": "+data.getStringExtra("archivo"));
				//Cuadro de progreso que se mostrara mientras dure la transferencia
				pd = ProgressDialog.show(this, getString(R.string.receiving)+"...", getString(R.string.receiving_file)+": "+data.getStringExtra("archivo"), true, true, new DialogInterface.OnCancelListener() {
					@Override
					public void onCancel(DialogInterface dialog) {
						//closeConnection();
						vncCanvas.handler.post(new Runnable() {
							public void run() {
								log.log(TAG, "Tranferencia abortada");
								notificacion.notificar(getString(R.string.transfer_aborted));
								pd.setMessage(getString(R.string.transfer_aborted));
								vncCanvas.enableRepaints();
								ft.fAbort=true;
							}
						});
					}
				});
						
			}
		//Si no se ha seleccionado ningn archivo
		}else if (requestCode == RESULT_CANCELED){
			Toast.makeText(this, getString(R.string.no_file_selected), Toast.LENGTH_SHORT).show();
			archivo=null;
		}
		
	}
	
	/**
	 * Touches and dpad (trackball) pan the screen
	 * @author Michael A. MacDonald
	 *
	 */
	class PanMode implements AbstractInputHandler
	{

		/* (non-Javadoc)
		 * @see android.androidVNC.AbstractInputHandler#onKeyDown(int, android.view.KeyEvent)
		 */
		@Override
		public boolean onKeyDown(int keyCode, KeyEvent evt) {
			// DPAD KeyDown events are move MotionEvents in Panning Mode
			final int dPos = 100;
			boolean result=false;
			switch (keyCode) {
			case KeyEvent.KEYCODE_DPAD_CENTER:
				result=true;
				break;
			case KeyEvent.KEYCODE_DPAD_LEFT:
				onTouchEvent(MotionEvent.obtain(1, System.currentTimeMillis(), MotionEvent.ACTION_MOVE, panTouchX + dPos, panTouchY, 0));
				result=true;
				break;
			case KeyEvent.KEYCODE_DPAD_RIGHT:
				onTouchEvent(MotionEvent.obtain(1, System.currentTimeMillis(), MotionEvent.ACTION_MOVE, panTouchX - dPos, panTouchY, 0));
				result=true;
				break;
			case KeyEvent.KEYCODE_DPAD_UP:
				onTouchEvent(MotionEvent.obtain(1, System.currentTimeMillis(), MotionEvent.ACTION_MOVE, panTouchX, panTouchY + dPos, 0));
				result=true;
				break;
			case KeyEvent.KEYCODE_DPAD_DOWN:
				onTouchEvent(MotionEvent.obtain(1, System.currentTimeMillis(), MotionEvent.ACTION_MOVE, panTouchX, panTouchY - dPos, 0));
				result=true;
				break;
			default:
				result=defaultKeyDownHandler( keyCode, evt);
				break;
			}
			return result;
		}

		/* (non-Javadoc)
		 * @see android.androidVNC.AbstractInputHandler#onKeyUp(int, android.view.KeyEvent)
		 */
		@Override
		public boolean onKeyUp(int keyCode, KeyEvent evt) {
			// Ignore KeyUp events for DPAD keys in Panning Mode; trackball button switches to mouse mode
			switch (keyCode) {
			case KeyEvent.KEYCODE_DPAD_CENTER :
				inputHandler=getInputHandlerById(R.id.itemInputMouse);
				connection.setInputMode(inputHandler.getName());
				connection.save(database.getWritableDatabase());
				updateInputMenu();
				showPanningState();
				return true;
			case KeyEvent.KEYCODE_DPAD_LEFT:
				return true;
			case KeyEvent.KEYCODE_DPAD_RIGHT:
				return true;
			case KeyEvent.KEYCODE_DPAD_UP:
				return true;
			case KeyEvent.KEYCODE_DPAD_DOWN:
				return true;
			}
			return defaultKeyUpHandler( keyCode, evt);
		}

		/* (non-Javadoc)
		 * @see android.androidVNC.AbstractInputHandler#onTouchEvent(android.view.MotionEvent)
		 */
		@Override
		public boolean onTouchEvent(MotionEvent event) {
			return touchPan(event);
		}

		/* (non-Javadoc)
		 * @see android.androidVNC.AbstractInputHandler#onTrackballEvent(android.view.MotionEvent)
		 */
		@Override
		public boolean onTrackballEvent(MotionEvent evt) {
			return false;
		}

		/* (non-Javadoc)
		 * @see android.androidVNC.AbstractInputHandler#handlerDescription()
		 */
		@Override
		public CharSequence getHandlerDescription() {
			return getResources().getText(R.string.input_mode_panning);
		}

		/* (non-Javadoc)
		 * @see android.androidVNC.AbstractInputHandler#getName()
		 */
		@Override
		public String getName() {
			return "PAN_MODE";
		}
		
	}
	
	/**
	 * The touchscreen pans the screen; the trackball moves and clicks the mouse.
	 * @author Michael A. MacDonald
	 *
	 */
	public class TouchPanTrackballMouse implements AbstractInputHandler {

		/* (non-Javadoc)
		 * @see android.androidVNC.AbstractInputHandler#onKeyDown(int, android.view.KeyEvent)
		 */
		@Override
		public boolean onKeyDown(int keyCode, KeyEvent evt) {
			return defaultKeyDownHandler(keyCode, evt);
		}

		/* (non-Javadoc)
		 * @see android.androidVNC.AbstractInputHandler#onKeyUp(int, android.view.KeyEvent)
		 */
		@Override
		public boolean onKeyUp(int keyCode, KeyEvent evt) {
			return defaultKeyUpHandler(keyCode, evt);
		}

		/* (non-Javadoc)
		 * @see android.androidVNC.AbstractInputHandler#onTouchEvent(android.view.MotionEvent)
		 */
		@Override
		public boolean onTouchEvent(MotionEvent evt) {
			return touchPan(evt);
		}

		/* (non-Javadoc)
		 * @see android.androidVNC.AbstractInputHandler#onTrackballEvent(android.view.MotionEvent)
		 */
		@Override
		public boolean onTrackballEvent(MotionEvent evt) {
			return trackballMouse(evt);
		}

		/* (non-Javadoc)
		 * @see android.androidVNC.AbstractInputHandler#handlerDescription()
		 */
		@Override
		public CharSequence getHandlerDescription() {
			return getResources().getText(R.string.input_mode_touchpad_pan_trackball_mouse);
		}

		/* (non-Javadoc)
		 * @see android.androidVNC.AbstractInputHandler#getName()
		 */
		@Override
		public String getName() {
			return "TOUCH_PAN_TRACKBALL_MOUSE";
		}
		
	}

	static final String FIT_SCREEN_NAME = "FIT_SCREEN";
	
	/**
	 * In fit-to-screen mode, no panning.  Trackball and touchscreen work as mouse.
	 * @author Michael A. MacDonald
	 *
	 */
	public class FitToScreenMode implements AbstractInputHandler {

		/* (non-Javadoc)
		 * @see android.androidVNC.AbstractInputHandler#onKeyDown(int, android.view.KeyEvent)
		 */
		@Override
		public boolean onKeyDown(int keyCode, KeyEvent evt) {
			return defaultKeyDownHandler(keyCode, evt);
		}

		/* (non-Javadoc)
		 * @see android.androidVNC.AbstractInputHandler#onKeyUp(int, android.view.KeyEvent)
		 */
		@Override
		public boolean onKeyUp(int keyCode, KeyEvent evt) {
			return defaultKeyUpHandler(keyCode, evt);
		}

		/* (non-Javadoc)
		 * @see android.androidVNC.AbstractInputHandler#onTouchEvent(android.view.MotionEvent)
		 */
		@Override
		public boolean onTouchEvent(MotionEvent evt) {
			return false;
		}

		/* (non-Javadoc)
		 * @see android.androidVNC.AbstractInputHandler#onTrackballEvent(android.view.MotionEvent)
		 */
		@Override
		public boolean onTrackballEvent(MotionEvent evt) {
			return trackballMouse(evt);
		}

		/* (non-Javadoc)
		 * @see android.androidVNC.AbstractInputHandler#handlerDescription()
		 */
		@Override
		public CharSequence getHandlerDescription() {
			return getResources().getText(R.string.input_mode_fit_to_screen);
		}

		/* (non-Javadoc)
		 * @see android.androidVNC.AbstractInputHandler#getName()
		 */
		@Override
		public String getName() {
			return FIT_SCREEN_NAME;
		}
		
	}

	/**
	 * Touch screen controls, clicks the mouse.
	 * @author Michael A. MacDonald
	 *
	 */
	class MouseMode implements AbstractInputHandler {

		/* (non-Javadoc)
		 * @see android.androidVNC.AbstractInputHandler#onKeyDown(int, android.view.KeyEvent)
		 */
		@Override
		public boolean onKeyDown(int keyCode, KeyEvent evt) {
			if ( keyCode==KeyEvent.KEYCODE_DPAD_CENTER)
				return true;
			return defaultKeyDownHandler( keyCode, evt);
		}

		/* (non-Javadoc)
		 * @see android.androidVNC.AbstractInputHandler#onKeyUp(int, android.view.KeyEvent)
		 */
		@Override
		public boolean onKeyUp(int keyCode, KeyEvent evt) {
			if ( keyCode==KeyEvent.KEYCODE_DPAD_CENTER)
			{
				inputHandler=getInputHandlerById( R.id.itemInputPan);
				showPanningState();
				connection.setInputMode(inputHandler.getName());
				connection.save(database.getWritableDatabase());
				updateInputMenu(); 
				return true;
			}
			return defaultKeyDownHandler( keyCode, evt);
		}

		/* (non-Javadoc)
		 * @see android.androidVNC.AbstractInputHandler#onTouchEvent(android.view.MotionEvent)
		 */
		@Override
		public boolean onTouchEvent(MotionEvent event) {
			// Mouse Pointer Control Mode
			// Pointer event is absolute coordinates.

			// Adjust coordinates for Android notification bar.
			event.offsetLocation(0, -1f * vncCanvas.getTop());

			// Adjust coordinates for panning position.
			event.offsetLocation(absoluteXPosition, absoluteYPosition);
			if (vncCanvas.processPointerEvent(event,true))
				return true;
			return VncCanvasActivity.super.onTouchEvent(event);
		}

		/* (non-Javadoc)
		 * @see android.androidVNC.AbstractInputHandler#onTrackballEvent(android.view.MotionEvent)
		 */
		@Override
		public boolean onTrackballEvent(MotionEvent evt) {
			return false;
		}

		/* (non-Javadoc)
		 * @see android.androidVNC.AbstractInputHandler#handlerDescription()
		 */
		@Override
		public CharSequence getHandlerDescription() {
			return getResources().getText(R.string.input_mode_mouse);
		}

		/* (non-Javadoc)
		 * @see android.androidVNC.AbstractInputHandler#getName()
		 */
		@Override
		public String getName() {
			return "MOUSE";
		}
		
	}
}
