/* 
 * This is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,
 * USA.
 */
/** 
	 * mContentProvider.java
	 * Autor: Alberto Poblacin Navarro
	 * Aadido al proyecto en la version v0.2.8
	 * Aadido a:
	 		* Proyecto original: http://code.google.com/p/android-vnc-viewer/
	 		* Release: 39
	 		* Migrada a release 60.
	 		* Web de ayuda: http://www.techjini.com/blog/2009/01/10/android-tip-1-contentprovider-accessing-local-file-system-from-webview-showing-image-in-webview-using-content/ 
*/
package android.androidVNC;

import java.io.File;
import java.io.FileNotFoundException;

import android.content.ContentProvider;
import android.content.ContentValues;
import android.database.Cursor;
import android.net.Uri;
import android.os.Environment;
import android.os.ParcelFileDescriptor;

/**
 * <p>(Se omiten acentos)
 * <p>Clase que permite que un archivo HTML local creado por una actividad sea abierto por otra.
 * Solo utilizamos la funcion openFile, el resto no es necesario implementar.</p>
 * <p>Fichero: mContentProvider.java.</p>
 * <p>Aadido al PFC en la version v0.2.8</p>
 * <p><b>Proyecto original:</b></p>
 * 		<p>Web: http://code.google.com/p/android-vnc-viewer/.</p>
 * 		<p>Release: 39.</p>
 *	 	<p>Migrada a release 60.</p>
 * @author Alberto Poblacion Navarro
 */
public class mContentProvider extends ContentProvider{

	/**
	 * Automaticamente se llama a esta funcion cuando se intenta abrir un archivo mediante 
	 * el "protocolo" content://. La utilizacion de este ContentProvider esta declarado en el AndroidManifest.xml
	 * En esta caso conocemos el archivo que vamos ha abrir por lo que directamente en la funcion abrimos el fichero
	 * teniendo en cuenta si la tarjeta de memoria esta o no montada.
	 * No se utilizan los parametros de llamda de la funcion
	 *   
	 */
	@Override
	public ParcelFileDescriptor openFile(Uri uri, String mode) throws FileNotFoundException {
		File file =null;
		String sdcard_status = Environment.getExternalStorageState();
		//Comprobamos si hay un medio extraible y creamos el archivo en la tarjeta si es posible
		if(sdcard_status.equals(Environment.MEDIA_MOUNTED))
        	file = new File("/sdcard/androidVNC.html");
		else file = new File("/data/data/android.androidVNC/androidVNC.html");
		ParcelFileDescriptor parcel = ParcelFileDescriptor.open(file, ParcelFileDescriptor.MODE_READ_ONLY);  
		return parcel;
			  
	} 
	@Override
	public int delete(Uri uri, String selection, String[] selectionArgs) {
		return 0;
	}

	@Override
	public String getType(Uri uri) {
		return null;
	}

	@Override
	public Uri insert(Uri uri, ContentValues values) {
		return null;
	}

	@Override
	public boolean onCreate() {
		return false;
	}

	@Override
	public Cursor query(Uri uri, String[] projection, String selection,
			String[] selectionArgs, String sortOrder) {
		return null;
	}

	@Override
	public int update(Uri uri, ContentValues values, String selection,
			String[] selectionArgs) {
		return 0;
	}
	

}
